//prof. Alin Burta
#include <fstream>
#include <cstring>
#include <iostream>

#define Nmax 252
#define in "parchet.in"
#define ou "parchet.out"

using namespace std;

unsigned int A[Nmax][Nmax], n, m, c, p, v;
unsigned int C[1001], ST[1001];
unsigned int S[1000];      //suprefetele camerelor
int x[21];      //pt. generare de submultimi
unsigned int cam;        //cate camere am acoperit
unsigned int maxim, nrmaxim, NrCam;


void uneste(unsigned int a, unsigned int b)
{
    unsigned int q, cop, t;
    if (a > b) cop = a, a = b, b = cop;
    cop = b; t = S[b] + S[a];
    for(q = 1; q <= NrCam; ++q)
        if(C[q] == cop)
            C[q] = a;
    for(q = 1; q <= NrCam; ++q)
        if(C[q] == a)
            S[q] = t;
}


int main()
{
    char linie[Nmax];
    unsigned int i,j, k, ok, ii, jj,t, nr;
    unsigned int sup, pus, putere;

    ifstream f(in);
    f>>v>>n>>m>>p;
    f.get();
    sup = 0;
    for(i=1; i<=n; ++i)
    {
        f.get(linie,m+1); f.get();
        //cout<<linie<<endl;
        for(j=0; j<m; ++j)
            if(linie[j] == 'P')
                A[i][j+1] = -1;
            else
                A[i][j+1] = 0;
    }
    f.close();
    NrCam = 0;

        //caut primul colt de camera neacoperit
        for(i=1; i<=n-1; ++i)
            for(j=1; j<=m-1; ++j)
                if( A[i][j]==0 )  //am gasit un colt
                {
                    //umplu linia cu nrcamerei
                    ok = 1; NrCam++; ii = i; jj = j; sup = 0;
                    while(ok)
                    {
                        ok = 0; //cout<<ii<<' '<<jj<<endl;
                        if( A[ii+1][jj] == 0) ok = jj ;

                        for(k=jj-1; A[ii][k]==0; k--)
                        {
                            if(A[ii][k] == 0) A[ii][k] = NrCam, sup++;
                            if(A[ii+1][k] == 0) ok = k;
                        }
                        for(k=jj+1; A[ii][k]==0; k++)
                        {
                            if(A[ii][k] == 0) A[ii][k] = NrCam, sup++;
                            if(A[ii+1][k] == 0) ok = k;
                        }
                        A[ii][jj] = NrCam; sup++;
                        ii++;
                        jj = ok;
                    }
                    S[NrCam] = sup;
                }

    ofstream g(ou);

    //unesc camerele
    for(i=1; i<=NrCam; ++i)
        C[i] = i;
    for(i=2; i<n; ++i)
        for(j=2; j<m; ++j)
        {
            if( A[i][j] != -1 && A[i-1][j] != -1 && A[i][j] != A[i-1][j] && C[ A[i][j] ] != C [ A[i-1][j] ] ) uneste( C[ A[i][j] ], C[ A[i-1][j] ]);
            if( A[i][j] != -1 && A[i][j+1] != -1 && A[i][j] != A[i][j+1] && C[ A[i][j] ] != C [ A[i][j+1] ] ) uneste( C[ A[i][j] ], C[ A[i][j+1] ]);
            if( A[i][j] != -1 && A[i+1][j] != -1 && A[i][j] != A[i+1][j] && C[ A[i][j] ] != C [ A[i+1][j] ] ) uneste( C[ A[i][j] ], C[ A[i+1][j] ]);
            if( A[i][j] != -1 && A[i][j-1] != -1 && A[i][j] != A[i][j-1] && C[ A[i][j] ] != C [ A[i][j-1] ] ) uneste( C[ A[i][j] ], C[ A[i][j-1] ]);
        }


    for(i=1; i<=1000; ++i) ST[i] = 0;
    for(i=1; i<=NrCam; ++i)
        ST[C[i]] = S[i];

    //sortez descrescator
    for(i=1; i<1000; ++i)
        for(j=i+1; j<=1000; ++j)
            if(ST[i]<ST[j]) t = ST[i], ST[i] = ST[j], ST[j] = t;

    while( ST[NrCam] == 0)
        NrCam--;

    for(i=1; i<=NrCam; ++i)
        S[i] = ST[i];

    //cerinta 1
    pus = 0;
    cam = 0;
    while(pus <= p && S[cam+1] <= p-pus)
            pus +=S[cam+1], cam++;

    if( v == 1)
    {
        if(NrCam == 1 && S[1]<=p)
            g<<1<<' '<<p-pus<<'\n';
        else
            g<<cam<<' '<<p-pus<<'\n';
    }
    if( v == 2)
    {
        //cerinta 2
        putere = 1; pus = 0;
        for(i=1; i<=NrCam; ++i)
            x[i] = 0, putere *=2, pus +=S[i] ;
        putere/=2;

        if(pus == p)
            g<<"1\n";
        else
        {
            maxim = 0; nrmaxim = 0;
            for(k = 1; k<putere; ++k)
            {
                t = 1; pus = 0;
                for(j=1; j<=NrCam && t; ++j)
                    ii = x[j] + t, x[j] = ii % 2, t = ii / 2;
                nr = 0;
                for(j=NrCam; j>=1; --j)
                    if(x[j]==1) pus += S[j], nr++;
                if(pus == p)
                    if(nr > maxim)
                        maxim = nr, nrmaxim = 1;
                    else
                        if(nr == maxim)
                            nrmaxim++;

                nr = 0; pus = 0;
                for(j=NrCam; j>=1; --j)
                    if(x[j]==0) pus += S[j], nr++;
                if(pus == p)
                    if(nr > maxim)
                        maxim = nr, nrmaxim = 1;
                    else
                        if(nr == maxim)
                            nrmaxim++;
            }
            g<<nrmaxim<<endl;
        }

    }
    g.close();
    return 0;
}
